# DrawingTools.py
# Name: Alex Cappiello
# AndrewID: acappiel
# Section: H
# Term project for 15-110, spring 2011
# All code original work unless otherwise noted

import MouseOps, Effects, Dialogs, Gui
from Tkinter import SUNKEN, RAISED
from PIL import Image, ImageDraw

################################################################################
    
def blankImage( width, height ):
    #create a new image
    canvas.data.rawImage = Image.new( 'RGB', ( width, height ),
                                          color = ( 255, 255, 255 ) )
    canvas.data.path = ""
    canvas.data.size = ( width, height )
    canvas.data.redraw = True

################################################################################

def setLineWidth( size ):
    canvas.data.lineWidth = size

def setColor( color, identifier ):
    #some things need hex colors, othere rgb
    #identifier corresponds to primary and secondary color
    if ( identifier == 1 ):
        canvas.data.rgbColorA = color[ 0 ] 
        canvas.data.hexColorA = color[ 1 ] 
    elif ( identifier == 2 ):
        canvas.data.rgbColorB = color[ 0 ]
        canvas.data.hexColorB = color[ 1 ]
    #some pointers need resetting again...
    configure()

def setTool( name ):
    #set buttons and new tool
    Gui.main.pointers[ canvas.data.activeToolName ].configure( relief=RAISED )
    canvas.data.activeToolName = name
    canvas.data.activeTool = mouseTools[ name ]
    canvas.data.action = canvas.data.activeTool[ 0 ]()
    Gui.main.pointers[ canvas.data.activeToolName ].configure( relief=SUNKEN )

################################################################################

def pixelMod( function ):
    #change an image pixel by pixel for a given function
    global imageTools
    canvas.data.unsavedChanges = True
    pix = canvas.data.rawImage.load()
    for row in xrange( canvas.data.size[ 0 ] ):
        for col in xrange(canvas.data.size[1]):
            pix[row,col] = imageTools[function](pix[row,col])
    canvas.data.redraw = True

################################################################################

def configure():
    #(re)create pointers
    global imageTools, mouseTools
    canvas.data.draw = ImageDraw.Draw( canvas.data.rawImage )
    imageTools = dict()
    mouseTools = dict()
    imageTools[ "grayscale" ] = Effects.grayscale
    imageTools[ "sepia" ] = Effects.sepia
    imageTools[ "brightness" ] = Effects.brightness
    #          name       class           tkaction     PILaction
    mouseTools["Eraser"]=[MouseOps.Brush, "#ffffff",   (255,255,255)           ]
    mouseTools["Brush" ]=[MouseOps.Brush, canvas.data.hexColorA,
                          canvas.data.rgbColorA                                ]
    mouseTools["Eyedrop"]=[MouseOps.Eyedrop, None,     None                    ]
    mouseTools["Fill"  ]=[MouseOps.Fill,  None,        None                    ]
    mouseTools["Line"  ]=[MouseOps.Line,  canvas.create_line,
                          canvas.data.draw.line                                ]
    mouseTools["Rectangle"]=[MouseOps.DrawShape, canvas.create_rectangle,
                             canvas.data.draw.rectangle                        ]
    mouseTools["Ellipse"]=[MouseOps.DrawShape,canvas.create_oval,
                           canvas.data.draw.ellipse                            ]
    mouseTools["Polygon"]=[MouseOps.Polygon, None,     None                    ]
    setTool( canvas.data.activeToolName )
